﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

// Using statements added for processing multiple result sets.
using System.Data.Entity.Infrastructure;
using System.Data.Objects;

namespace TestModelFirst
{
   public partial class Form1 : Form
   {
      public Form1()
      {
         InitializeComponent();
      }

      private void btnAdd_Click(object sender, EventArgs e)
      {
         // Create a new purchase.
         Purchases NewPurchase = new Purchases();
         NewPurchase.Amount = new Decimal(5.99);
         NewPurchase.PurchaseDate = DateTime.Now;

         // Create a new customer and add the purchase.
         Customers NewCustomer = new Customers();
         NewCustomer.CustomerName = "Josh Bailey";

         // Create the context.
         Rewards2ModelContainer context = new Rewards2ModelContainer();

         // Add the record and save it.
         context.Customers.Add(NewCustomer);
         context.Purchases.Add(NewPurchase);
         context.SaveChanges();

         // Display a success message.
         MessageBox.Show("Record Added");
      }

      private void btnQuery_Click(object sender, EventArgs e)
      {
          // Create the context.
          Rewards2ModelContainer context = new Rewards2ModelContainer();

          // Obtain the customer list.
          var CustomerList =
              from cust in context.Customers
              select cust;

          //// Obtain the customer list in list form.
          //List<Customers> CustomerList =
          //    (from cust in context.Customers
          //     select cust).ToList<Customers>();

          // Process each customer in the list.
          StringBuilder Output = 
              new StringBuilder("Customer List:");
          foreach (var Customer in CustomerList)
          {
              // Create a customer entry for each customer.
              Output.Append("\r\n" + Customer.CustomerName + 
                  " has made purchases on: ");

              // Process each purchase for that particular customer.
              foreach (var Purchase in Customer.Purchases)
                  Output.Append("\r\n\t" + Purchase.PurchaseDate);
          }

          // Display the result on screen.
          MessageBox.Show(Output.ToString());
      }

      private void btnCoded_Click(object sender, EventArgs e)
      {
         // Create the context.
         Rewards2ModelContainer context = new Rewards2ModelContainer();

         // Create a command to execute.
         var Cmd = context.Database.Connection.CreateCommand();

         // Set the command to execute.
         Cmd.CommandText = "MultipleResultSet";

         try
         {
            // Open a connection to the database.
            context.Database.Connection.Open();

            // Execute the stored procedure and save the results.
            var Reader = Cmd.ExecuteReader();

            // Access the first result set.
            var Results = ((IObjectContextAdapter)context)
               .ObjectContext
               .Translate<MultipleResultData>(Reader);

            // Process the first result set.
            StringBuilder Output = new StringBuilder("Josh Bailey Purchases: ");
            foreach (var Result in Results)
            {
               Output.Append("\r\n\t" + Result.PurchaseDate +
                  " for " + Result.Amount);
            }

            // Access the second result set.
            Reader.NextResult();
            Results = ((IObjectContextAdapter)context)
               .ObjectContext
               .Translate<MultipleResultData>(Reader);

            // Process the second result set.
            Output.Append("\r\nChristian Hess Purchases: ");
            foreach (var Result in Results)
            {
               Output.Append("\r\n\t" + Result.PurchaseDate + 
                  " for " + Result.Amount);
            }

            // Display the result on screen.
            MessageBox.Show(Output.ToString());
         }
         finally
         {
            // Make certain the database connection is closed.
            context.Database.Connection.Close();
         }
      }
   }

   public class MultipleResultData
   {
      public Int32 Cust_Id { get; set; }
      public String CustomerName { get; set; }
      public Int32 Purchase_Id { get; set; }
      public DateTime PurchaseDate {get; set;}
      public Decimal Amount { get; set; }
      public Int32 CustomersId { get; set; }
   }
}
